<copyright> TUG tom lexer.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright (C) 1998 Pieter J. Schoenmakers.

    This file is part of TESLA.  TESLA is distributed under the terms of
    the GNU General Public License, a copy of which can be found in the
    TESLA distribution; see the file COPYING.

    <id>$Id: LexScan.t,v 1.2 2000/02/24 10:51:16 tiggr Exp $</id>
    </copyright>

implementation class
LexScan: mu.Lexer, ClassScanDefines, tug
{
  static ByteArray humbug;
}

void
  load Array arguments
{
  humbug = "????????????????????????????????????????()??,?.???????????:;???????????????????????????????[?]?????????????????????????????{?}??";
}

void
  fillTokens
{
  [self addToken ("class", CLASS)];
  [self addToken ("end", END)];
  [self addToken ("extension", EXTENSION)];
  [self addToken ("implementation", IMPLEMENTATION)];
  [self addToken ("instance", INSTANCE)];
  [self addToken ("posing", POSING)];
}

end;

implementation instance
LexScan

int
  identifier
{
  if ([String (semantics) length] >= 3)
    {
      Token t = tokens[semantics];
      if (t != nil)
	return [t token];
    }

  = IDENTIFIER;
}

<doc> Convert all single-character tokens not being a {?} in {humbug}
    into {HUMBUG}.  </doc>
int (t)
  nextToken
{
  [super nextToken];
  if (token > 0 && token < 65536 && (token > 127 || humbug[token] == '?'))
    token = HUMBUG;
  = token;
}

int
  block-open
{
  = '{';
}

int
  block-close
{
  = '}';
}

int
  andand
{
  = HUMBUG;
}

int
  character
{
  = HUMBUG;
}

int
  eq
{
  = HUMBUG;
}

int
  ge
{
  = HUMBUG;
}

int
  implies
{
  = HUMBUG;
}

int
  le
{
  = HUMBUG;
}

int
  minusminus
{
  = HUMBUG;
}

int
  ne
{
  = HUMBUG;
}

int
  number
{
  = HUMBUG;
}

int
  oror
{
  = HUMBUG;
}

int
  plusplus
{
  = HUMBUG;
}

int
  shl
{
  = HUMBUG;
}

int
  shr
{
  = HUMBUG;
}

int
  lsr
{
  = HUMBUG;
}

int
  string
{
  = HUMBUG;
}

int
  div_is
{
  = HUMBUG;
}

int
  add_is
{
  = HUMBUG;
}

int
  implies_is
{
  = HUMBUG;
}

int
  sub_is
{
  = HUMBUG;
}

int
  sc_or_is
{
  = HUMBUG;
}

int
  or_is
{
  = HUMBUG;
}

int
  sc_and_is
{
  = HUMBUG;
}

int
  and_is
{
  = HUMBUG;
}

int
  lsr_is
{
  = HUMBUG;
}

int
  shl_is
{
  = HUMBUG;
}

int
  shr_is
{
  = HUMBUG;
}

int
  eor_is
{
  = HUMBUG;
}

int
  mul_is
{
  = HUMBUG;
}

end;
